package kz.arta.synergy.workflow.mobile.android.common.offline.add;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import java.util.ArrayList;
import java.util.List;

import kz.arta.synergy.workflow.mobile.android.common.models.offline.completion.OfflineCompletionWorkComment;

/**
 * Created by neox on 11.08.14.
 */
public class AddCompletionComment extends SQLiteOpenHelper {

    private SQLiteDatabase db = getWritableDatabase();
    private static final String TABLE_NAME = "AddFormCompletionComment";
    private static final String TABLE = "create table " + TABLE_NAME + " ("
            + "actionID text,"
            + "comment text,"
            + "name text"
            + ");";

    public AddCompletionComment(Context context) {
        super(context, TABLE_NAME, null, 1);
    }

    @Override
    public void onCreate(SQLiteDatabase sqLiteDatabase) {
        sqLiteDatabase.execSQL(TABLE);
    }

    @Override
    public void onUpgrade(SQLiteDatabase sqLiteDatabase, int i, int i2) {

    }

    public boolean remove() {
        try {
            db.delete(TABLE_NAME, null, null);
            return true;
        } catch (Exception exc) {
            return false;
        }
    }

    public boolean add(String actionID, String comment, String name) {
        try {
            db.delete(TABLE_NAME, "actionID = ?", new String[]{actionID});
            ContentValues cv = new ContentValues();
            cv.put("actionID", actionID);
            cv.put("comment", comment);
            cv.put("name", name);
            db.insert(TABLE_NAME, null, cv);
            return true;
        } catch (Exception exc) {
            return false;
        }
    }

    public List<OfflineCompletionWorkComment> get() {
        List<OfflineCompletionWorkComment> result = new ArrayList<>();
        Cursor c = null;
        try {
            c = db.query(TABLE_NAME, null, null, null, null, null, null);
            if (c.moveToFirst()) {
                do {
                    OfflineCompletionWorkComment item = new OfflineCompletionWorkComment();
                    item.setActionID(c.getString(c.getColumnIndex("actionID")));
                    item.setComment(c.getString(c.getColumnIndex("comment")));
                    item.setName(c.getString(c.getColumnIndex("name")));
                    result.add(item);
                } while (c.moveToNext());
            }
            return result;
        } catch (Exception exc) {
            return result;
        } finally {
            if (c != null) {
                c.close();
            }
        }
    }
}
